/*
--------------------------------------------------------------------------------

  build_net.h
  Interfaccia per la classe che costruisce la rete leggendo i file wgt

--------------------------------------------------------------------------------
*/  

#ifndef BUILD_NET_H
#define BUILD_NET_H

#include<iostream.h>
#include<fstream.h>
#include"act_fun.h"
#include"utils.h"
#include"tset.h"
#include"net.h"
#include"matrix.h"

/**
  Class for building a neural net stored onto a file - HTML documentation under construction.
	@memo Class for building a neural net stored onto a file
*/
class BuildNet  {

public:
  BuildNet() {}
  BuildNet(char* namefile, OneLayerTest** oln);
  virtual ~BuildNet() {}

  OneLayerTest* build(char* namefile); 
  act_func Decode_act_fun(unsigned fun); 
};

#endif
