#include<iostream>
#include<fstream>
#include<strstream>
#include"decomp.h"

using namespace std;

int main (int argc, char *argv[]) {
 
 unsigned ro;
 const unsigned DIMBUF = 256;
 char namebuf[DIMBUF];
 
 if (argc != 3) 
	 error_exit ("Usage: peximizeHD matrixfile_to_be_read base_matrix_name");
	 
 d_Rand d(argv[1]);
 strcpy(namebuf,argv[2]);
 
 d.print_matrix();
 cout << "Decompostion matrix read: " << endl;
 cout << "Min Hamming dist: " << d.MinHamming() << endl;
 cout << "Avg Hamming dist: " << d.Avg_Hamming_distance() << endl;
 cout << "Min Dichotomy dist: " << d.Min_Dichotomy_distance() << endl;
 cout << "Avg Dichotomy dist: " << d.Avg_Dichotomy_distance() << endl;
 
 
 d_Rand_gr_equal_constraints * d2 = new d_Rand(d); 
 
 for(;;) {
 d_Rand_gr_equal_constraints * d3 = d2->decrementHD(1, 1, false);
 if (d3!=NULL) {
   d3->print_matrix();
	 ro = d3->MinHamming();
	 cout << "Min Hamming dist: " << ro << endl;
   cout << "Avg Hamming dist: " << d3->Avg_Hamming_distance() << endl;
   cout << "Min Dichotomy dist: " << d3->Min_Dichotomy_distance() << endl;
   cout << "Avg Dichotomy dist: " << d3->Avg_Dichotomy_distance() << endl;
   ostrstream ost(namebuf,DIMBUF);
   ost << argv[2] << ro << '\0'; 
   ofstream fcv(namebuf);
   if (!fcv) error_exit("Cannot open file ", namebuf);
   d3->save_matrix(fcv);	 
	 delete d2; 
	 d2 = d3;
 }
 else {
   d3 = d2->decrementHD(1, 1, true);
   if (d3!=NULL){
     d3->print_matrix();
	   ro = d3->MinHamming();
	   cout << "Min Hamming dist: " << ro << endl;
     cout << "Avg Hamming dist: " << d3->Avg_Hamming_distance() << endl;
     cout << "Min Dichotomy dist: " << d3->Min_Dichotomy_distance() << endl;
     cout << "Avg Dichotomy dist: " << d3->Avg_Dichotomy_distance() << endl;
     ostrstream ost(namebuf,DIMBUF);
     ost << argv[2] << ro << '\0';
     ofstream fcv(namebuf);
     if (!fcv) error_exit("Cannot open file ", namebuf);
     d3->save_matrix(fcv);
	   delete d2;
	   d2 = d3;
   }
	 else {
     cout << "Stop at  " << ro << "  Hamming distance." << endl;
	   delete d2;
	   break;
	 }
 }
}
 
 //ofstream f("decmatrix");
 //d.save_matrix(f);
 
 //d_Rand d2("decmatrix");
 //d2.print_matrix();



return 0;
}
